#include "Barrel.h"
#include "LD37.h"
#include "Particle.h"
extern LD37* game;
extern int ENTCOUNT;
Barrel::Barrel(ALLEGRO_BITMAP* g) : Entity(g)
{
	srcx = 0;
	srcy = 16;
	liftable = true;
	layer = 500;
	cleaned = false;
}


void Barrel::Update()
{
	Entity::Update();
	if (!cleaned)
	{
		for (int i = 0; i < ENTCOUNT; ++i)
		{
			if (game->ents[i] != nullptr)
			{
				if (game->ents[i]->x == x && game->ents[i]->y == y && game->ents[i] != this)
				{
					Barrel* b = dynamic_cast<Barrel*>(game->ents[i]);
					if (b != NULL)
					{
						game->RemoveEnt(b, true);
					}
				}
			}
		}
		cleaned = true;
	}
	if (thrown)
	{
		if (TryMove(thx, thy))
		{
			if (!game->p_col) { al_play_sample(game->s_col, 0.5f, 0.0f, 1.0f, ALLEGRO_PLAYMODE_ONCE, 0); game->p_col = true; }
			killMe = true;
			Particle* p = new Particle(graphic, 0, 32, 3, 5);
			p->x = x;
			p->y = y;
			game->AddEnt(p);
			p = nullptr;
		}
	}
	
}

void Barrel::Render()
{
	Entity::HandleTransition();
	if (thrown)
	{
		angle += 0.2f;
	}
	else
	{
		angle = 0.0f;
	}
	al_draw_tinted_scaled_rotated_bitmap_region(graphic, srcx, srcy, 16, 16, al_map_rgb(255, 255, 255), 8, 8, tx+8, ty+8, 1.0f, 1.0f, angle, 0);
}

Barrel::~Barrel()
{
}

void Barrel::Bump(Entity* perp)
{
	if (perp != nullptr) 
	{
		if (perp->thrown)
		{
			if (!game->p_col) { al_play_sample(game->s_col, 0.5f, 0.0f, 1.0f, ALLEGRO_PLAYMODE_ONCE, 0); game->p_col = true; }
			killMe = true;
			Particle* p = new Particle(graphic, 0, 32, 3, 5);
			p->x = x;
			p->y = y;
			game->AddEnt(p);
			p = nullptr;
		}
	}
}