#pragma once
#ifndef ENTITY_H
#define ENTITY_H

#include <iostream>
#include <allegro5\allegro.h>
#include <allegro5\allegro_acodec.h>
#include <allegro5\allegro_audio.h>
#include <allegro5\allegro_image.h>

using namespace std;

class Entity
{
public:
	Entity(ALLEGRO_BITMAP* g);
	~Entity();
	virtual void Update();
	virtual void Render();
	int x;
	int y;
	int srcx;
	int srcy;
	bool solid = true;
	bool liftable = false;
	bool thrown = false;
	int thx = 0;
	int thy = 0;
	int thdmg = 2;
	bool killMe = false;
	int layer;
	int px; //Previous Position
	int py;
	float tx; //Transition Position
	float ty;
protected:
	ALLEGRO_BITMAP* graphic;
	bool TryMove(int dx, int dy);
	bool CanWalk(int xx, int yy, bool dodgeBarrel=false, bool includePlayer=false);
	virtual void Bump(Entity* perp);
	void HandleTransition();
};
#endif

