#include "LD37.h"

int ENTCOUNT = 256;
extern ALLEGRO_FONT* font;
extern int state;
extern ALLEGRO_SAMPLE_ID* music;
extern ALLEGRO_SAMPLE* musicSample;

LD37::LD37()
{
	nTurns = 0;
	clearBoard = false;
	etime = 0;
	ctime = 0;
	equantity = 1;
	cspeed = 100;
	hspeed = 20;
	dspeed = 40;
	htime = 0;
	dtime = 0;
	numEnts = 0;
	needToSort = false;
	got = 0;
}

void LD37::Init()
{
	al_stop_samples();
	s_col = al_load_sample("assets/collision.wav"); p_col = false;
	s_crystal = al_load_sample("assets/crystal_get.wav");
	s_death = al_load_sample("assets/death.wav"); p_death = false;
	s_expl = al_load_sample("assets/explosion.wav");
	s_hurt = al_load_sample("assets/hurt.wav"); p_hurt = false;
	s_pickup = al_load_sample("assets/pickup.wav");
	s_throw = al_load_sample("assets/throw.wav"); p_throw = false;
	s_item = al_load_sample("assets/item.wav"); p_item = false;
	s_pdeath = al_load_sample("assets/cog_death.wav");
	for (int i = 0; i < 20; ++i)
	{
		for (int j = 0; j < 15; ++j)
		{
			board[i][j] = 0;
			if (i >= 2 && i < 18)
			{
				if (j >= 2 && j < 13) 
				{
					board[i][j] = 1;
				}
				else if (j == 13)
				{
					board[i][j] = 2;
				}
				else if (j > 13)
				{
					board[i][j] = 3;
				}
			}
		}
	}
	time_t timer = 0;
	time(&timer);
	srand((unsigned int)timer);
	renderTarget = al_create_bitmap(320, 240);
	b_actors = al_load_bitmap("assets/actors.tga");
	b_tiles = al_load_bitmap("assets/tiles.bmp");
	ents = new Entity*[ENTCOUNT];
	for (int i = 0; i < ENTCOUNT; ++i)
	{
		ents[i] = nullptr;
	}
	ply = new Player(b_actors);
	ply->x = 10;
	ply->y = 7;
	ply->tx = 160;
	ply->ty = 112;
	for (int i = 0; i < 16; i++)
	{
		int xx = rand() % 16 + 2;
		int yy = rand() % 11 + 2;
		if (xx != ply->x || yy != ply->y)
		{
			for (int j = 0; j < ENTCOUNT; ++j)
			{
				if (ents[j] != nullptr)
				{
					if (ents[j]->x == xx && ents[j]->y == yy)
					{
						continue;
					}
				}
			}
			ents[i] = new Barrel(b_actors);
			ents[i]->x = xx;
			ents[i]->y = yy;
			ents[i]->tx = xx * 16;
			ents[i]->ty = yy * 16;
		}
	}
	for (int i = 0; i < 2; ++i)
	{
		SpawnEnemy();
	}
	//if (state == 1) al_play_sample(musicSample, 1.0f, 0.0f, 1.0f, ALLEGRO_PLAYMODE_LOOP, music);
}

void LD37::Update()
{
	if (keys[ALLEGRO_KEY_W]==true || keys[ALLEGRO_KEY_X]==true 
		|| keys[ALLEGRO_KEY_Z]==true || keys[ALLEGRO_KEY_C]==true 
		|| keys[ALLEGRO_KEY_Q]==true || keys[ALLEGRO_KEY_E]==true
		|| keys[ALLEGRO_KEY_A]==true || keys[ALLEGRO_KEY_D]==true
		|| keys[ALLEGRO_KEY_G]==true)
	{
		if (t == 0) keyp = true;
	}
	if (t > 0)
	{
		t -= 1;
	}
	if (keys[ALLEGRO_KEY_F10])
	{
		ctime = cspeed - 3;
	}
	if (keyp && t == 0 && ply->health > 0)
	{
		p_col = false;
		p_death = false;
		p_hurt = false;
		p_throw = false;
		p_item = false;
		ply->hrt = false;
		t = 10;
		
		keyp = false;
		for (int i = 0; i < ENTCOUNT; ++i)
		{
			if (ents[i] != nullptr)
			{
				if (ents[i]->killMe == false) ents[i]->Update();
			}
		}
		ply->Update();
		for (int i = 0; i < ENTCOUNT; ++i)
		{
			if (ents[i] != nullptr)
			{
				if (ents[i]->killMe)
				{
					RemoveEnt(ents[i], true);
				}
			}
		}
		if (needToSort)
		{
			SortEntities();
			needToSort = false;
		}
		
		if (etime > 10)
		{
			etime = 0;
			for (int i = 0; i < equantity; ++i) 
			{
				SpawnEnemy();
			}
		}
		if (htime > hspeed)
		{
			htime = 0;
			int x = rand() % 16 + 2;
			int y = rand() % 11 + 2;
			bool grecc = false;
			for (int i = 0; i < ENTCOUNT; ++i)
			{
				if (ents[i] != nullptr)
				{
					if (ents[i]->x == x && ents[i]->y == y && ents[i]->solid)
					{
						grecc = true;
						break;
					}
				}
			}
			if (!grecc) 
			{
				HPack* hp = new HPack(b_actors);
				hp->x = x;
				hp->y = y;
				AddEnt(hp);
				hp = nullptr;
			}
		}
		if (dtime > dspeed)
		{
			dtime = 0;
			int x = rand() % 16 + 2;
			int y = rand() % 11 + 2;
			bool grecc = false;
			for (int i = 0; i < ENTCOUNT; ++i)
			{
				if (ents[i] != nullptr)
				{
					if (ents[i]->x == x && ents[i]->y == y && ents[i]->solid)
					{
						grecc = true;
						break;
					}
				}
			}
			if (!grecc)
			{
				DGet* dg = new DGet(b_actors);
				dg->x = x;
				dg->y = y;
				AddEnt(dg);
				dg = nullptr;
			}
		}
		if (ctime >= cspeed) //Happens on 2,
		{
			ctime = 0;
			for (int i = 0; i < ENTCOUNT; ++i)
			{
				if (ents[i] != nullptr)
				{
					if (ents[i]->x == 11 && ents[i]->y == 8)
					{
						RemoveEnt(ents[i], true);
					}
				}
			}
			Crystal* c = new Crystal(b_actors);
			c->x = 11;
			c->y = 8;
			if (ply->x == 11 && ply->y == 8)
			{
				for (int i = 0; i < ENTCOUNT; ++i)
				{
					if (ents[i] != nullptr)
					{
						if (ents[i]->x == 10 && ents[i]->y == 7)
						{
							RemoveEnt(ents[i], true);
						}
					}
				}
				ply->x = 10;
				ply->y = 7;
			}
			AddEnt(c);
			if (ply->crystals == 1 || ply->crystals >= 3) equantity = 2;
			if (ply->crystals == 2) equantity = 1;
			cspeed += 30;
			dspeed -= 2;
			hspeed = 20;
			
			c = nullptr;
		}
		if (ply->crystals >= 5)
		{
			state = 5;
			//al_stop_samples();
			return;
		}
		if (clearBoard)
		{
			clearBoard = false;
			for (int i = 0; i < ENTCOUNT; ++i)
			{
				if (ents[i] != nullptr)
				{
					RemoveEnt(ents[i], true);
					ents[i] = nullptr;
				}
			}
			for (int i = 0; i < 16 - (ply->crystals * 3); i++)
			{
				int xx = rand() % 16 + 2;
				int yy = rand() % 11 + 2;
				if (xx != ply->x || yy != ply->y) 
				{
					for (int j = 0; j < ENTCOUNT; ++j)
					{
						if (ents[j] != nullptr)
						{
							if (ents[j]->x == xx && ents[j]->y == yy)
							{
								continue;
							}
						}
					}
					ents[i] = new Barrel(b_actors);
					ents[i]->x = xx;
					ents[i]->y = yy;
					ents[i]->tx = xx * 16;
					ents[i]->ty = yy * 16;
				}
			}
			for (int i = 0; i < 1 + ply->crystals; ++i)
			{
				SpawnEnemy();
			}
			if (ply->crystals >= 2)
			{
				for (int i = 0; i < 2 + ply->crystals; ++i)
				{
					Shrek* shr = new Shrek(b_actors);

					shr->x = rand() % 16 + 2;
					shr->y = rand() % 11 + 2;
					if (shr->x == ply->x && shr->y == ply->y) shr->x += 2;

					for (int j = 0; j < ENTCOUNT; ++j)
					{
						if (ents[j] != nullptr)
						{
							if (ents[j]->x == shr->x && ents[j]->y == shr->y)
							{
								RemoveEnt(ents[j], true);
							}
						}
					}

					AddEnt(shr);
					shr = nullptr;
				}
			}
		}
		nTurns += 1;
		ctime += 1;
		etime += 1;
		htime += 1;
		dtime += 1;
		if (ply->health <= 0)
		{
			for (int i = -1; i < 2; ++i)
			{
				for (int j = -1; j < 2; ++j)
				{
					Particle* pt = new Particle(b_actors, 64, 48, 4, 5);
					pt->x = ply->x + i;
					pt->y = ply->y + j;
					AddEnt(pt);
					pt = nullptr;
				}
			}
			al_stop_samples();
			al_play_sample(s_pdeath, 1.0f, 0.0f, 1.0f, ALLEGRO_PLAYMODE_ONCE, 0);
		}
	}


	al_set_target_bitmap(renderTarget);
	al_clear_to_color(al_map_rgb(0, 0, 0));

	for (int i = 0; i < 20; i++)
	{
		for (int j = 0; j < 15; j++)
		{
			if (board[i][j] > 0)
			{
				
				al_draw_bitmap_region(b_tiles, board[i][j] * 16, 0, 16, 16, i*16, j*16, 0);
			}
		}
	}
	if (screenFlash > 0)
	{
		screenFlash -= 5;
		if (screenFlash < 0) screenFlash = 0;
	}
	for (int i = 0; i < ply->maxhealth; ++i)
	{
		al_draw_tinted_bitmap_region(b_tiles, al_map_rgb(128, 128, 128), 0, 32, 8, 8, 32 + i * 8, 4, 0);
	}
	for (int i = 0; i < ply->health; ++i)
	{
		
		al_draw_bitmap_region(b_tiles, 0, 32, 8, 8, 32 + i*8, 4, 0);
	}
	al_draw_text(font, al_map_rgb(255, 255, 255), 8, 4, 0, "HP:");
	al_draw_bitmap_region(b_actors, 0, 48, 16, 16, 28, 12, 0);

	string str = string("x");
	str += (ply->dynamites+48);
	al_draw_text(font, al_map_rgb(255, 255, 255), 48, 16, 0, str.c_str()); //Dy counter
	str = string("x");
	str += (ply->crystals + 48);
	al_draw_text(font, al_map_rgb(255, 255, 255), 272, 16, 0, str.c_str());
	al_draw_bitmap_region(b_actors, 16, 48, 16, 16, 256, 8, 0); //Crystal counter

	for (int i = 0; i < ENTCOUNT; ++i)
	{
		if (ents[i] != nullptr)
		{
			ents[i]->Render();
		}
	}

	al_set_blender(ALLEGRO_ADD, ALLEGRO_ALPHA, ALLEGRO_INVERSE_ALPHA);
	al_draw_filled_rectangle(0, 0, 320, 240, al_map_rgba(255, 255, 255, screenFlash));
	al_set_blender(ALLEGRO_ADD, ALLEGRO_ONE, ALLEGRO_INVERSE_ALPHA);
	
	ply->Render();
	if (ply->health <= 0)
	{
		ply->srcx = 32;
		ply->srcy = 0;
		got += 1;
		if (got > 100) 
		{
			got = 0;
			state = 2;
		}
	}
}

void LD37::DeInit()
{
	al_destroy_sample(s_col);
	al_destroy_sample(s_crystal);
	al_destroy_sample(s_death);
	al_destroy_sample(s_expl);
	al_destroy_sample(s_hurt);
	al_destroy_sample(s_pickup);
	al_destroy_sample(s_item);
	al_destroy_sample(s_throw);
	al_destroy_sample(s_pdeath);
	al_destroy_bitmap(b_tiles);
	al_destroy_bitmap(b_actors);
	al_destroy_bitmap(renderTarget);
	delete ply;
	for (int i = 0; i < ENTCOUNT; ++i)
	{
		if (ents[i] != nullptr)
		{
			delete ents[i];
		}
	}
	
	delete[] ents;
}

void LD37::RemoveEnt(Entity* ent, bool delmem)
{
	for (int i = 0; i < ENTCOUNT; ++i)
	{
		if (ents[i] == ent)
		{
			if (delmem) delete ents[i];
			ents[i] = nullptr;
			needToSort = true;
			break;
		}
	}
}

void LD37::AddEnt(Entity* ent)
{
	for (int i = 0; i < ENTCOUNT; ++i)
	{
		if (ents[i] == nullptr)
		{
			ents[i] = ent;
			needToSort = true;
			return;
		}
		if (ents[i] == ent)
		{
			cout << "IT'S ALREADY IN THE LIST!!!" << endl;
			return;
		}
	}
	cout << "ENTITY LIMIT REACHED, BUCKO!" << endl;
}

void LD37::SortEntities()
{
	for (int k = 5; k >= 1; --k)
	{
		for (int i = k; i < ENTCOUNT; ++i)
		{
			int h = i;
			while (h >= k)
			{
				int l1 = 0;
				int l2 = 0;
				if (ents[h - k] != nullptr)
				{
					l1 = ents[h - k]->layer;
				}
				if (ents[h] != nullptr)
				{
					l2 = ents[h]->layer;
				}
				if (l1 > l2)
				{
					Entity* buffer = ents[h - k];
					ents[h - k] = ents[h];
					ents[h] = buffer;
					h -= k;
				}
				else
				{
					break;
				}
			}
		}
	}
}

void LD37::SpawnEnemy()
{
	int s = rand() % 4;
	int x = 0; //rand() % 16 + 2;
	int y = 0; //rand() % 11 + 2
	switch (s)
	{
	case 0: //Top
		x = rand() % 16 + 2;
		y = 1;
		break;
	case 1: //Bottom
		x = rand() % 16 + 2;
		y = 12;
		break;
	case 2: //Left
		x = 1;
		y = rand() % 11 + 2;
		break;
	case 3: //Right
		x = 17;
		y = rand() % 11 + 2;
		break;
	}

	bool grecc = false;
	for (int i = 0; i < ENTCOUNT; ++i)
	{
		if (ents[i] != nullptr)
		{
			if (ents[i]->x == x && ents[i]->y == y)
			{
				grecc = true;
				break;
			}
		}
	}
	if (x == ply->x && y == ply->y) grecc = true;
	if (!grecc) {
		Enemy* enm = new Enemy(b_actors);
		enm->x = x;
		enm->y = y;
		enm->tx = x * 16;
		enm->ty = y * 16;
		AddEnt(enm);
		enm = nullptr;
	}
}

LD37::~LD37()
{
}
