#include "Shrek.h"
#include "LD37.h"

extern LD37* game;
extern int ENTCOUNT;

Shrek::Shrek(ALLEGRO_BITMAP* g) : Enemy(g)
{
	liftable = false;
	solid = true;
	srcx = 64;
	srcy = 16;
	health = 3;
	php = 3;
	layer = 50;
	melee = false;
	ftime = 0;
}

void Shrek::Update()
{
	if (!dead && !thrown) {
		ftime += 1;
		if (ftime > 4)
		{
			//if (!game->p_throw) { al_play_sample(game->s_throw, 0.5f, 0.0f, 1.0f, ALLEGRO_PLAYMODE_ONCE, 0); game->p_throw = true; }
			ftime = 0;
			Fireball* f = new Fireball(graphic);
			f->x = x;
			f->y = y;
			int r = rand() % 8;
			switch (r)
			{
			case 0: //Right
				f->x = x + 1;
				f->y = y;
				f->thx = 1;
				f->thy = 0;
				break;
			case 1: //URight
				f->x = x + 1;
				f->y = y - 1;
				f->thx = 1;
				f->thy = -1;
				break;
			case 2: //Up
				f->x = x;
				f->y = y - 1;
				f->thx = 0;
				f->thy = -1;
				break;
			case 3: //ULeft
				f->x = x - 1;
				f->y = y - 1;
				f->thx = -1;
				f->thy = -1;
				break;
			case 4: //Left
				f->x = x - 1;
				f->y = y;
				f->thx = -1;
				f->thy = 0;
				break;
			case 5: //DLeft
				f->x = x - 1;
				f->y = y + 1;
				f->thx = -1;
				f->thy = 1;
				break;
			case 6: //Down
				f->x = x;
				f->y = y + 1;
				f->thx = 0;
				f->thy = 1;
				break;
			case 7: //DRight
				f->x = x + 1;
				f->y = y + 1;
				f->thx = 1;
				f->thy = 1;
				break;
			}
			f->tx = f->x * 16;
			f->ty = f->y * 16;
			game->AddEnt(f);
			f = nullptr;
		}
	}
}

void Shrek::Damage(int amt)
{
	health -= amt;
	flash = 255;
	if (health <= 0)
	{
		dead = true;
		solid = false;
		liftable = true;
		srcx = 80;
		srcy = 16;
		layer = 5;
		game->SortEntities();
		if (!game->p_death) { al_play_sample(game->s_death, 0.5f, 0.0f, 1.0f, ALLEGRO_PLAYMODE_ONCE, 0); game->p_death = true; }
	}
	else
	{
		if (!game->p_hurt)
		{
			al_play_sample(game->s_hurt, 0.5f, 0.0f, 1.0f, ALLEGRO_PLAYMODE_ONCE, 0); 
			game->p_hurt = true;
		}
	}
}


Shrek::~Shrek()
{
}
